<?php
namespace Magento\Catalog\Api\Data;

/**
 * ExtensionInterface class for @see \Magento\Catalog\Api\Data\ProductInterface
 */
interface ProductExtensionInterface extends \Magento\Framework\Api\ExtensionAttributesInterface
{
    /**
     * @return int[]|null
     */
    public function getWebsiteIds();

    /**
     * @param int[] $websiteIds
     * @return $this
     */
    public function setWebsiteIds($websiteIds);

    /**
     * @return \Magento\Catalog\Api\Data\CategoryLinkInterface[]|null
     */
    public function getCategoryLinks();

    /**
     * @param \Magento\Catalog\Api\Data\CategoryLinkInterface[] $categoryLinks
     * @return $this
     */
    public function setCategoryLinks($categoryLinks);

    /**
     * @return \Magento\Bundle\Api\Data\OptionInterface[]|null
     */
    public function getBundleProductOptions();

    /**
     * @param \Magento\Bundle\Api\Data\OptionInterface[] $bundleProductOptions
     * @return $this
     */
    public function setBundleProductOptions($bundleProductOptions);

    /**
     * @return \Magento\CatalogInventory\Api\Data\StockItemInterface|null
     */
    public function getStockItem();

    /**
     * @param \Magento\CatalogInventory\Api\Data\StockItemInterface $stockItem
     * @return $this
     */
    public function setStockItem(\Magento\CatalogInventory\Api\Data\StockItemInterface $stockItem);

    /**
     * @return \Magento\Downloadable\Api\Data\LinkInterface[]|null
     */
    public function getDownloadableProductLinks();

    /**
     * @param \Magento\Downloadable\Api\Data\LinkInterface[] $downloadableProductLinks
     * @return $this
     */
    public function setDownloadableProductLinks($downloadableProductLinks);

    /**
     * @return \Magento\Downloadable\Api\Data\SampleInterface[]|null
     */
    public function getDownloadableProductSamples();

    /**
     * @param \Magento\Downloadable\Api\Data\SampleInterface[] $downloadableProductSamples
     * @return $this
     */
    public function setDownloadableProductSamples($downloadableProductSamples);

    /**
     * @return \Magento\ConfigurableProduct\Api\Data\OptionInterface[]|null
     */
    public function getConfigurableProductOptions();

    /**
     * @param \Magento\ConfigurableProduct\Api\Data\OptionInterface[] $configurableProductOptions
     * @return $this
     */
    public function setConfigurableProductOptions($configurableProductOptions);

    /**
     * @return int[]|null
     */
    public function getConfigurableProductLinks();

    /**
     * @param int[] $configurableProductLinks
     * @return $this
     */
    public function setConfigurableProductLinks($configurableProductLinks);

    /**
     * @return string|null
     */
    public function getThumbnailResizedUrl();

    /**
     * @param string $thumbnailResizedUrl
     * @return $this
     */
    public function setThumbnailResizedUrl($thumbnailResizedUrl);

    /**
     * @return string|null
     */
    public function getThumbnailUrl();

    /**
     * @param string $thumbnailUrl
     * @return $this
     */
    public function setThumbnailUrl($thumbnailUrl);

    /**
     * @return \Deity\MagentoApi\Api\Data\GalleryMediaEntrySizeInterface[]|null
     */
    public function getMediaGallerySizes();

    /**
     * @param \Deity\MagentoApi\Api\Data\GalleryMediaEntrySizeInterface[] $mediaGallerySizes
     * @return $this
     */
    public function setMediaGallerySizes($mediaGallerySizes);

    /**
     * @return float|null
     */
    public function getCatalogDisplayPrice();

    /**
     * @param float $catalogDisplayPrice
     * @return $this
     */
    public function setCatalogDisplayPrice($catalogDisplayPrice);

    /**
     * @return float|null
     */
    public function getMinPrice();

    /**
     * @param float $minPrice
     * @return $this
     */
    public function setMinPrice($minPrice);

    /**
     * @return float|null
     */
    public function getMaxPrice();

    /**
     * @param float $maxPrice
     * @return $this
     */
    public function setMaxPrice($maxPrice);

    /**
     * @return \Deity\MagentoApi\Api\Data\BreadcrumbInterface[]|null
     */
    public function getBreadcrumbs();

    /**
     * @param \Deity\MagentoApi\Api\Data\BreadcrumbInterface[] $breadcrumbs
     * @return $this
     */
    public function setBreadcrumbs($breadcrumbs);
}
