<?php
namespace Magento\Sales\Api\Data;

/**
 * Extension class for @see \Magento\Sales\Api\Data\OrderItemInterface
 */
class OrderItemExtension extends \Magento\Framework\Api\AbstractSimpleObject implements OrderItemExtensionInterface
{
    /**
     * @return \Magento\GiftMessage\Api\Data\MessageInterface|null
     */
    public function getGiftMessage()
    {
        return $this->_get('gift_message');
    }

    /**
     * @param \Magento\GiftMessage\Api\Data\MessageInterface $giftMessage
     * @return $this
     */
    public function setGiftMessage(\Magento\GiftMessage\Api\Data\MessageInterface $giftMessage)
    {
        $this->setData('gift_message', $giftMessage);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getThumbnailUrl()
    {
        return $this->_get('thumbnail_url');
    }

    /**
     * @param string $thumbnailUrl
     * @return $this
     */
    public function setThumbnailUrl($thumbnailUrl)
    {
        $this->setData('thumbnail_url', $thumbnailUrl);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getUrlKey()
    {
        return $this->_get('url_key');
    }

    /**
     * @param string $urlKey
     * @return $this
     */
    public function setUrlKey($urlKey)
    {
        $this->setData('url_key', $urlKey);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getLink()
    {
        return $this->_get('link');
    }

    /**
     * @param string $link
     * @return $this
     */
    public function setLink($link)
    {
        $this->setData('link', $link);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getCurrency()
    {
        return $this->_get('currency');
    }

    /**
     * @param string $currency
     * @return $this
     */
    public function setCurrency($currency)
    {
        $this->setData('currency', $currency);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getDisplayPrice()
    {
        return $this->_get('display_price');
    }

    /**
     * @param string $displayPrice
     * @return $this
     */
    public function setDisplayPrice($displayPrice)
    {
        $this->setData('display_price', $displayPrice);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getRowTotalInclTax()
    {
        return $this->_get('row_total_incl_tax');
    }

    /**
     * @param string $rowTotalInclTax
     * @return $this
     */
    public function setRowTotalInclTax($rowTotalInclTax)
    {
        $this->setData('row_total_incl_tax', $rowTotalInclTax);
        return $this;
    }

    /**
     * @return string|null
     */
    public function getOptions()
    {
        return $this->_get('options');
    }

    /**
     * @param string $options
     * @return $this
     */
    public function setOptions($options)
    {
        $this->setData('options', $options);
        return $this;
    }
}
